<template>
  <div>
    <div id="nav" class="navigation">
      <ul id="diveList" style="list-style-type: none">
        <div v-for="data in navigationData" :key="data.id">
          <li
            class="flex-parent dive-entry"
            :class="{ active: data.id == activeIndex }"
            v-if="isItemFiltered(data)"
          >
            <input
              v-if="editMode"
              :id="data.id"
              :value="data.id"
              type="checkbox"
              @change="check($event)"
            />
            <div class="flex-parent dive-description">
              <router-link
                class="flex-item"
                :to="{
                  name: 'diveId',
                  params: { diveId: data.id },
                }"
              >
                <label>{{ getDiveDescription(data) }}</label>
              </router-link>
              <label class="flex-item edit" v-if="editMode">{{
                getCoordDescription(data)
              }}</label>
            </div>
          </li>
        </div>
      </ul>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "diveNavigation",
  data: function () {
    return {
      activeIndex: null,
      filterPlaces: this.$store.state.filterPlaces,
    };
  },
  props: {
    editMode: Boolean,
  },
  methods: {
    getDiveDescription(data) {
      return data.date + " - " + data.time;
    },
    getCoordDescription(data) {
      let desc = "Coord: ";
      if (data.googleMapsCoordinates.lat == null) {
        return desc + "- / -";
      }
      return (
        desc +
        data.googleMapsCoordinates.lat.toFixed(2) +
        " / " +
        data.googleMapsCoordinates.lng.toFixed(2)
      );
    },
    isItemFiltered(data) {
      if (this.$store.getters.isIdChecked(data.id)) {
        return true;
      }

      let hasCoordinates = data.googleMapsCoordinates != null;
      switch (this.$store.state.filterPlaces) {
        case process.env.VUE_APP_FILTER_PLACES_ALL:
          return true; // all items showed
        case process.env.VUE_APP_FILTER_PLACES_WITH:
          return hasCoordinates; //show only dives with coordinates
        case process.env.VUE_APP_FILTER_PLACES_WITHOUT:
          return !hasCoordinates; //show dives without coordinates
        default:
          console.log("something went wrong on places filter. show all");
          return true; //something went wrong
      }
    },
    check: function (e) {
      const isChecked = e.target.checked;
      const diveId = e.target.id;
      if (isChecked) {
        this.$store.commit("addCheckedDive", diveId);
      } else {
        this.$store.commit("removeCheckedDive", diveId);
      }
    },
  },
  beforeCreate() {
    axios.get("getDivesDateTime").then((response) => {
      this.$store.commit("navigationData", response.data);
    });
  },
  computed: {
    navigationData() {
      return this.$store.state.navigationData;
    },
  },
};
</script>

<style scoped>
#nav a {
  color: #2c3e50;
}
#nav a.router-link-exact-active {
  color: #42b983;
}
ul {
  padding-inline-start: 5px;
}
.flex-parent.dive-description {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: flex-start;
  align-content: flex-start;
}
.flex-parent.dive-entry {
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  align-items: stretch;
  justify-content: flex-start;
  align-content: flex-start;
}

.flex-item.edit {
  flex: 1 100%;
  text-align: left;
  margin-left: 20px;
}
</style>
